



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java读写资源文件类Properties</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java读写资源文件类Properties</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 09:10:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java中读写资源文件最重要的类是Properties</p>
<p>1) 资源文件要求如下:</p>
<div>1、properties文件是一个文本文件</div>
<div>2、properties文件的语法有两种，一种是注释，一种属性配置。</div>
<div>&nbsp;注&nbsp;&nbsp;&nbsp; 释：前面加上#号</div>
<div>&nbsp;属性配置：以&ldquo;键=值&rdquo;的方式书写一个属性的配置信息。</div>
<div>3、properties文件的一个属性配置信息值可以换行，但键不可以换行。值换行用&ldquo;\&rdquo;表示。</div>
<div>4、properties的属性配置键值前后的空格在解析时候会被忽略。</div>
<div>5、properties文件可以只有键而没有值。也可以仅有键和等号而没有值，但无论如何一个属性配置不能没有键。</div>
<div>eg:</div>
<div>正确的资源文件格式为：</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/300877/201407/231053576508248.jpg" /></div>
<div>&nbsp;</div>
<p>2) 功能大致如下：</p>
<div>1. 读写Properties文件</div>
<div>2. 读写XML文件</div>
<div>3. 不仅可以读写上述两类文件，还可以读写其它格式文件如txt等，只要符合key=value格式即可.</div>
<div>Properties能读取以key,value存储的任何格式文件，看一下他的类结构就知道为什么了</div>
<div><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/300877/201407/231057236048795.jpg" /></div>
<div>从上面的类结构图可以看出，它继承了Hashtable并实现了Map接口</div>
<div>&nbsp;</div>
<div>3）代码演示：</div>
<div>
<div>
<div>
<pre class="prettyprint linenums"> package com.ifly.myhome.test;

 import java.io.File;<br />
 import java.io.FileInputStream;<br />
 import java.io.FileOutputStream;<br />
 import java.io.IOException;<br />
 import java.io.InputStream;<br />
 import java.io.OutputStream;<br />
 import java.io.UnsupportedEncodingException;<br />
 import java.util.Properties;

 public class PropertiesMyTest<br />
 {

     public static void main(String[] args)<br />
     {

         String readfile = "e:" + File.separator + "readfile.properties";<br />
         String writefile = "e:" + File.separator + "writefile.properties";<br />
         String readxmlfile = "e:" + File.separator + "readxmlfile.xml";<br />
         String writexmlfile = "e:" + File.separator + "writexmlfile.xml";<br />
         String readtxtfile = "e:" + File.separator + "readtxtfile.txt";<br />
         String writetxtfile = "e:" + File.separator + "writetxtfile.txt";

         readPropertiesFile(readfile); //读取properties文件<br />
         writePropertiesFile(writefile); //写properties文件<br />
         readPropertiesFileFromXML(readxmlfile); //读取XML文件<br />
         writePropertiesFileToXML(writexmlfile); //写XML文件<br />
         readPropertiesFile(readtxtfile); //读取txt文件<br />
         writePropertiesFile(writetxtfile); //写txt文件<br />
     }

     //读取资源文件,并处理中文乱码<br />
     public static void readPropertiesFile(String filename)<br />
     {<br />
         Properties properties = new Properties();<br />
         try<br />
         {<br />
             InputStream inputStream = new FileInputStream(filename);<br />
             properties.load(inputStream);<br />
             inputStream.close(); //关闭流<br />
         }<br />
         catch (IOException e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
         String username = properties.getProperty("username");<br />
         String passsword = properties.getProperty("password");<br />
         String chinese = properties.getProperty("chinese");<br />
         try<br />
         {<br />
             chinese = new String(chinese.getBytes("ISO-8859-1"), "GBK"); // 处理中文乱码<br />
         }<br />
         catch (UnsupportedEncodingException e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
         System.out.println(username);<br />
         System.out.println(passsword);<br />
         System.out.println(chinese);<br />
     }

     //读取XML文件,并处理中文乱码<br />
     public static void readPropertiesFileFromXML(String filename)<br />
     {<br />
         Properties properties = new Properties();<br />
         try<br />
         {<br />
             InputStream inputStream = new FileInputStream(filename);<br />
             properties.loadFromXML(inputStream);<br />
             inputStream.close();<br />
         }<br />
         catch (IOException e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
         String username = properties.getProperty("username");<br />
         String passsword = properties.getProperty("password");<br />
         String chinese = properties.getProperty("chinese"); //XML中的中文不用处理乱码，正常显示<br />
         System.out.println(username);<br />
         System.out.println(passsword);<br />
         System.out.println(chinese);<br />
     }

     //写资源文件，含中文<br />
     public static void writePropertiesFile(String filename)<br />
     {<br />
         Properties properties = new Properties();<br />
         try<br />
         {<br />
             OutputStream outputStream = new FileOutputStream(filename);<br />
             properties.setProperty("username", "myname");<br />
             properties.setProperty("password", "mypassword");<br />
             properties.setProperty("chinese", "中文");<br />
             properties.store(outputStream, "author: shixing_11@sina.com");<br />
             outputStream.close();<br />
         }<br />
         catch (IOException e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
     }

     //写资源文件到XML文件，含中文<br />
     public static void writePropertiesFileToXML(String filename)<br />
     {<br />
         Properties properties = new Properties();<br />
         try<br />
         {<br />
             OutputStream outputStream = new FileOutputStream(filename);<br />
             properties.setProperty("username", "myname");<br />
             properties.setProperty("password", "mypassword");<br />
             properties.setProperty("chinese", "中文");<br />
             properties.storeToXML(outputStream, "author: shixing_11@sina.com");<br />
             outputStream.close();<br />
         }<br />
         catch (IOException e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
     }

 }</pre>
</div>
</div>
</div>
<div>
<div>
<div>运行本程序所需的资源文件，我是放在E盘根目录，如E:/readfile.properties</div>
<div>1. readfile.properties</div>
</div>
<blockquote><div>username=kh</div>
<div>password=kh</div>
<div>chinese=谓语</div></blockquote>
<div>2.&nbsp;writefile.properties</div>
<blockquote><div>#author: shixing_11@sina.com</div>
<div>#Fri May 28 22:19:44 CST 2010</div>
<div>password=kh</div>
<div>chinese=\u8C13\u8BED</div>
<div>username=kh</div></blockquote>
<p>3.&nbsp;readxmlfile.xml</p>
<blockquote><blockquote>&lt;?xml version="1.0" encoding="UTF-8" standalone="no"?&gt;</p></blockquote>
<blockquote><p>&lt;!DOCTYPE properties SYSTEM "http://java.sun.com/dtd/properties.dtd"&gt;</p></blockquote>
<blockquote><p>&lt;properties&gt;</p></blockquote>
<blockquote><p>&lt;entry key="password"&gt;mypassword&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;entry key="chinese"&gt;中文&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;entry key="username"&gt;myname&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;/properties&gt;</p></blockquote></blockquote>
<div>4.&nbsp;writexmlfile.xml</div>
<blockquote><blockquote>&lt;?xml version="1.0" encoding="UTF-8" standalone="no"?&gt;</p></blockquote>
<blockquote><p>&lt;!DOCTYPE properties SYSTEM "http://java.sun.com/dtd/properties.dtd"&gt;</p></blockquote>
<blockquote><p>&lt;properties&gt;</p></blockquote>
<blockquote><p>&lt;entry key="password"&gt;kh&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;entry key="chinese"&gt;中文&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;entry key="username"&gt;kh&lt;/entry&gt;</p></blockquote>
<blockquote><p>&lt;/properties&gt;</p></blockquote></blockquote>

<p><em><em>5. readtxtfile.txt &nbsp; &nbsp;</em></em></p>
<div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;username=kh</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;password=kh</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;chinese=中文</div>
<div>6.&nbsp;writetxtfile.txt</div>
</div>
<div>&nbsp;</div>
<div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;password=kh</div>
</div>
<div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;chinese=/u4E2D/u6587</div>
</div>
<div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;username=kh</div>
<div>&nbsp;</div>
<div>4)Properties获取数据乱码解决</div>
</div>
</div>
<div>
<p>1.原因</p>
<p>Properties调用load(InputStream)时，读取文件时使用的默认编码为ISO-8859-1；当我们讲中文放入到properties文件中，通过getProperty(key)获取值时，取到得数据是ISO-8859-1格式的，但是ISO-8859-1是不能识别中文的。</p>
<p>2.解决方法</p>
<p>通过getProperty()获取的数据data既然是ISO-8859-1编码的，就通过data.getByte(&ldquo;iso-8859-1&rdquo;)获取获取，使用new String(data.getByte(&ldquo;iso-8859-1&rdquo;),&rdquo;UTF-8&rdquo;)进行转换。当然properties文件的编码类型需要和new String(Byte[],charst)中的第二个参数的编码类型相同</p>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvrwdx8.html">asp&period;net  各种路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96keo4q.html">ffmpeg-20160811-bin&period;7z</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6rye8.html">Oracle中用一条Sql实现任意的行转列拼接 多行拼接</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rjkdd8.html">CC2540 USB DONGLE 使用 BTool 调试BLE 说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzp7e8.html">HttpWebResponse返回信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd5ke38.html">java多线程模拟停车系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn102zx8.html">CMD命令窗口复制与粘贴</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1eg669.html">sql server语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2lo38.html">Linux企业级项目实践之网络爬虫（28）&mdash;&mdash;爬虫socket处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5pxr8.html">Hadoop 使用FileSystem API 读取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z72kk9.html">好题  线段树对数据的保存&plus;离线的逆向插入 POJ 2887</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k6jzz9.html">网站开发进阶&lpar;一&rpar;Tomcat域名或IP地址访问方式配置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1l6kzq.html">mybatis中  keyProperty&equals;&amp;quot&semi;id&amp;quot&semi; 的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1vjlxq.html">GUI 设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv4x4r8.html">Django的学习进阶（二）&mdash;&mdash;&mdash;&mdash; name</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2d4ee8.html">class-dump在osx 10&period;11以后安装方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/902dkdmq.html">javascript解析器原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pnrw08.html">test20190320 全连（fc）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvg3ejq.html">POJ 1163</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvepyvy9.html">chr&lpar;&rpar; 、ord&lpar;&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49g3kdeq.html">安装numpy库</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jegdw8.html">JS Date</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4422jq.html">wechall&period;net&sol;stegano 解题心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd53yj9.html">SpringMVC学习（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96mkvj8.html">HTML5本地存储&mdash;&mdash;Web SQL Database</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2xlvw9.html">python 线程之 threading&lpar;四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kmev39.html">Codeforces Round &num;352 &lpar;Div&period; 2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g3wkeq.html">div可编辑状态设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96me2n8.html">Leetcode Word Ladder</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e0vlxq.html">ACM&colon;    NBUT 1107  盒子游戏 - 简单博弈</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
